'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SVGPrev = require('./svg/SVGPrev');

var _SVGPrev2 = _interopRequireDefault(_SVGPrev);

var _SVGNext = require('./svg/SVGNext');

var _SVGNext2 = _interopRequireDefault(_SVGNext);

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _recompose = require('recompose');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _helperFunctions = require('./helperFunctions');

var _ = require('.');

var _reactSwipeable = require('react-swipeable');

var _reactSwipeable2 = _interopRequireDefault(_reactSwipeable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//implement acceleration
//write own swipeable with render props
//press for accelerated scroll
//center on select
//cure the 'freeze' bug

var interval = void 0;

var getContainerElement = function getContainerElement(_ref) {
  var props = _ref.props;
  var containerClass = props.containerClass,
      containerRef = props.containerRef,
      containerId = props.containerId;

  return (0, _helperFunctions.getElement)({ ref: containerRef, className: containerClass, id: containerId, debug: false });
};

var Accordion = function (_React$Component) {
  (0, _inherits3.default)(Accordion, _React$Component);

  function Accordion() {
    var _ref2,
        _this2 = this;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Accordion);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Accordion.__proto__ || (0, _getPrototypeOf2.default)(Accordion)).call.apply(_ref2, [this].concat(args))), _this), _this.containerRef = _react2.default.createRef(), _this.swipeableRef = _react2.default.createRef(), _this.handleScroll = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var _this$props, leeway, updateState, _this$props$state, showLeft, showRight, showUp, showDown, showLog, containerElement;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$props = _this.props, leeway = _this$props.leeway, updateState = _this$props.updateState, _this$props$state = _this$props.state, showLeft = _this$props$state.showLeft, showRight = _this$props$state.showRight, showUp = _this$props$state.showUp, showDown = _this$props$state.showDown, showLog = _this$props.showLog;
              containerElement = _this.swipeableRef.current && _this.swipeableRef.current.element;
              _context.next = 4;
              return (0, _helperFunctions.delay)(500);

            case 4:

              showLog && console.log('// handleScroll // ', 'containerElement.scrollLeft + leeway: ', containerElement.scrollLeft + leeway, 'scrollWidth: ', containerElement.scrollWidth, 'clientWidth: ', containerElement.clientWidth, 'diff: ', containerElement.scrollWidth - containerElement.clientWidth);

              if (!(containerElement.scrollLeft === 0 || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 11;
                break;
              }

              _context.next = 8;
              return updateState({ showLeft: false });

            case 8:
              clearInterval(interval);
              _context.next = 14;
              break;

            case 11:
              if (!(containerElement.scrollLeft > 0)) {
                _context.next = 14;
                break;
              }

              _context.next = 14;
              return updateState({ showLeft: true });

            case 14:
              if (!(containerElement.scrollLeft >= containerElement.scrollWidth - containerElement.clientWidth || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 20;
                break;
              }

              _context.next = 17;
              return updateState({ showRight: false });

            case 17:
              clearInterval(interval);
              _context.next = 23;
              break;

            case 20:
              if (!(containerElement.scrollWidth >= containerElement.clientWidth)) {
                _context.next = 23;
                break;
              }

              _context.next = 23;
              return updateState({ showRight: true });

            case 23:
              if (!(containerElement.scrollTop === 0 || containerElement.scrollHeight === containerElement.clientHeight)) {
                _context.next = 29;
                break;
              }

              _context.next = 26;
              return updateState({ showUp: false });

            case 26:
              clearInterval(interval);
              _context.next = 32;
              break;

            case 29:
              if (!(containerElement.scrollTop > 0)) {
                _context.next = 32;
                break;
              }

              _context.next = 32;
              return updateState({ showUp: true });

            case 32:
              if (!(containerElement.scrollTop === containerElement.scrollHeight - containerElement.clientHeight || containerElement.scrollHeight === containerElement.clientHeight)) {
                _context.next = 38;
                break;
              }

              _context.next = 35;
              return updateState({ showDown: false });

            case 35:
              clearInterval(interval);
              _context.next = 41;
              break;

            case 38:
              if (!(containerElement.scrollTop === 0)) {
                _context.next = 41;
                break;
              }

              _context.next = 41;
              return updateState({ showDown: true });

            case 41:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    })), _this.startScroll = function (e, direction) {
      e.stopPropagation();
      clearInterval(interval);

      var containerElement = _this.swipeableRef.current && _this.swipeableRef.current.element;

      if (containerElement) {
        interval = setInterval(function () {
          switch (direction) {
            case 'left':
              containerElement.scrollLeft -= 20;
              break;

            case 'right':
              containerElement.scrollLeft += 20;
              break;

            case 'up':
              console.log('up');
              containerElement.scrollTop = 0;
              break;

            case 'down':
              console.log('down');
              containerElement.scrollTop += 20;
              break;
          }
        }, 50);
      }
    }, _this.scroll = function (e, direction) {
      e.stopPropagation();
      var containerElement = _this.swipeableRef.current && _this.swipeableRef.current.element;
      if (containerElement) {
        switch (direction) {
          case 'left':
            containerElement.scrollLeft -= 10;
            break;
          case 'right':
            containerElement.scrollLeft += 10;
            break;
          case 'up':
            containerElement.scrollTop -= 10;
            break;
          case 'down':
            containerElement.scrollTop += 10;
            break;
        }
      }
    }, _this.endScroll = function (e) {
      e.stopPropagation();
      clearInterval(interval);
    }, _this.renderNav = function (direction) {
      var _this3 = _this,
          _this3$props = _this3.props,
          showLog = _this3$props.showLog,
          height = _this3$props.height,
          width = _this3$props.width,
          _this3$props$state = _this3$props.state,
          showLeft = _this3$props$state.showLeft,
          showRight = _this3$props$state.showRight,
          showUp = _this3$props$state.showUp,
          showDown = _this3$props$state.showDown,
          renderButton = _this3$props.renderButton,
          startScroll = _this3.startScroll,
          endScroll = _this3.endScroll;

      showLog && console.log('this.props: ', _this.props);

      var containerElement = _this.swipeableRef.current && _this.swipeableRef.current.element;

      showLog && console.log('containerElement: ', containerElement);

      var autoHeight = containerElement && containerElement.clientHeight;
      var autoWidth = 18;
      var vertWidth = containerElement && containerElement.clientWidth;
      var vertHeight = 18;

      var SVGProps = {
        fill: '#555',
        size: width ? width : autoWidth
      };
      var renderIcon = function renderIcon(_ref4) {
        var direction = _ref4.direction,
            props = (0, _objectWithoutProperties3.default)(_ref4, ['direction']);

        switch (direction) {
          case 'right':
            return _react2.default.createElement(_SVGNext2.default, (0, _extends3.default)({}, SVGProps, props));
          case 'left':
            return _react2.default.createElement(_SVGPrev2.default, (0, _extends3.default)({}, SVGProps, props));
          case 'up':
            return _react2.default.createElement(_SVGExpandLess2.default, (0, _extends3.default)({}, SVGProps, props));
          case 'down':
            return _react2.default.createElement(_SVGExpandMore2.default, (0, _extends3.default)({}, SVGProps, props));
        }
      };
      var inProp = function inProp(_ref5) {
        var direction = _ref5.direction;

        switch (direction) {
          case 'right':
            return showRight;
          case 'left':
            return showLeft;
          case 'up':
            return showUp;
          case 'down':
            return showDown;
        }
      };
      var getStyle = function getStyle(_ref6) {
        var direction = _ref6.direction;

        switch (direction) {
          case 'right':
            return {
              top: 0,
              width: width ? width : autoWidth,
              height: height ? height : autoHeight,
              right: 0
            };
          case 'left':
            return {
              top: 0,
              width: width ? width : autoWidth,
              height: height ? height : autoHeight
            };
          case 'up':
            return {
              top: 0,
              width: width ? width : vertWidth,
              height: height ? height : vertHeight
            };
          case 'down':
            return {
              bottom: 0,
              width: width ? width : vertWidth,
              height: height ? height : vertHeight
            };
        }
      };
      return _react2.default.createElement(
        _RTGTransition2.default,
        { in: inProp({ direction: direction }) },
        function (_ref7) {
          var transitionStyle = _ref7.style;

          var getButtonProps = function getButtonProps() {
            var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var style = _ref8.style,
                colors = _ref8.colors,
                props = (0, _objectWithoutProperties3.default)(_ref8, ['style', 'colors']);
            return {
              onMouseDown: function onMouseDown(e) {
                return startScroll(e, direction);
              },
              onMouseUp: endScroll,
              onTouchStart: function onTouchStart(e) {
                return startScroll(e, direction);
              },
              onTouchEnd: endScroll,
              className: 'accordion_navbutton accordion__navbutton--' + direction,
              colors: colors ? colors : _.buttonStyles.violet,
              style: (0, _extends3.default)({}, transitionStyle, {
                padding: 0,
                position: 'absolute'
              }, getStyle({ direction: direction }), style)
            };
          };
          return renderButton ? renderButton({ getButtonProps: getButtonProps, renderIcon: renderIcon, direction: direction }) : _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getButtonProps()),
            _react2.default.createElement(
              'div',
              { style: { background: '#fff' } },
              renderIcon({ direction: direction })
            )
          );
        }
      );
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Accordion, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.handleScroll();
      var containerElement = this.swipeableRef.current && this.swipeableRef.current.element;
      containerElement.addEventListener('scroll', this.handleScroll);
      window.addEventListener('resize', this.handleScroll);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      prevProps.children !== this.props.children && this.handleScroll(); // numberOfItems => children.length
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(interval);
      var containerElement = this.swipeableRef.current && this.swipeableRef.current.element;
      containerElement.removeEventListener('scroll', this.handleScroll);
      window.removeEventListener('resize', this.handleScroll);
    }
  }, {
    key: 'render',
    value: function render() {
      var swipeableRef = this.swipeableRef,
          containerRef = this.containerRef,
          startScroll = this.startScroll,
          endScroll = this.endScroll,
          scroll = this.scroll,
          _props = this.props,
          swipeableProps = _props.swipeableProps,
          state = _props.state;
      //console.log(swipeableRef.current && swipeableRef.current.element, containerRef)

      return typeof window !== 'undefined' && _react2.default.createElement(
        _react2.default.Fragment,
        null,
        this.renderNav('left'),
        this.renderNav('up'),
        _react2.default.createElement(
          _reactSwipeable2.default,
          (0, _extends3.default)({
            trackMouse: true,
            ref: swipeableRef,
            onSwiped: function onSwiped(e) {
              return endScroll(e);
            },
            onSwipingLeft: function onSwipingLeft(e, absX) {
              return scroll(e, 'left');
            },
            onSwipingRight: function onSwipingRight(e, absX) {
              return scroll(e, 'right');
            }
          }, swipeableProps),
          this.props.children
        ),
        this.renderNav('right'),
        this.renderNav('down')
      );
    }
  }]);
  return Accordion;
}(_react2.default.Component);

Accordion.defaultProps = {
  showLog: false,
  leeway: 0
};

Accordion.propTypes = {
  containerClass: _propTypes2.default.string,
  leeway: _propTypes2.default.number,
  width: _propTypes2.default.number
};

var enhance = (0, _recompose.compose)((0, _recompose.withStateHandlers)(function (_ref9) {
  var srcs = _ref9.srcs;
  return {
    state: { showLeft: false, showRight: false, showUp: false, showDown: false }
  };
}, {
  updateState: function updateState(_ref10) {
    var state = _ref10.state;
    return function (payload) {
      return { state: (0, _extends3.default)({}, state, payload) };
    };
  }
}), (0, _recompose.onlyUpdateForKeys)(['state', 'children', 'containerRef']));

exports.default = enhance(Accordion);