'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sign1 = '+';
var sign2 = '+';

var DetectCollision = function (_Component) {
  (0, _inherits3.default)(DetectCollision, _Component);

  function DetectCollision() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DetectCollision);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DetectCollision.__proto__ || (0, _getPrototypeOf2.default)(DetectCollision)).call.apply(_ref, [this].concat(args))), _this), _this.handleScroll = function () {
      var _this$props = _this.props,
          containerRef = _this$props.containerRef,
          onEntered = _this$props.onEntered,
          onExited = _this$props.onExited,
          isLocked = _this$props.isLocked,
          setFloatingStateTo = _this$props.setFloatingStateTo,
          leeway = _this$props.leeway;

      var containerElement = containerRef.current;
      var scrollHeight = document.body.scrollHeight;

      var _containerElement$get = containerElement.getBoundingClientRect(),
          rectTop = _containerElement$get.top,
          rectHeight = _containerElement$get.height;

      console.log('scrollHeight: ' + scrollHeight, 'rectTop: ' + rectTop, 'rectHeight: ' + rectHeight, 'window.scrollY: ' + window.scrollY, 'sum: ' + (rectTop + rectHeight + window.scrollY));
      if (!isLocked) {
        if (scrollHeight > rectTop + window.scrollY + rectHeight + leeway) {
          sign2 = '+';
        } else {
          sign2 = '-';
        }
      }

      if (sign1 !== sign2 && sign2 === '+') {
        console.log('lifted: switch to +', sign1, sign2);
        onEntered && onEntered();
        setFloatingStateTo(true);
        sign1 = '+';
      } else if (sign1 !== sign2 && sign2 === '-') {
        console.log('hit bottom: switch to -', sign1, sign2);
        onExited && onExited();
        setFloatingStateTo(false);
        sign1 = '-';
      }
    }, _this.componentDidMount = function () {
      typeof window !== 'undefined' && window.addEventListener('scroll', _this.handleScroll);
    }, _this.componentWillUnmount = function () {
      window.removeEventListener('scroll', _this.handleScroll);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DetectCollision, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isFloating = _props.isFloating,
          children = _props.children;

      return children({ isFloating: isFloating });
    }
  }]);
  return DetectCollision;
}(_react.Component);

DetectCollision.propTypes = {};
DetectCollision.defaultProps = {
  leeway: 200
};
var enhance = (0, _recompose.compose)((0, _recompose.withState)('isFloating', 'setFloatingStateTo', true));
exports.default = enhance(DetectCollision);