'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OutsideClickListener = function (_React$Component) {
  (0, _inherits3.default)(OutsideClickListener, _React$Component);

  function OutsideClickListener() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, OutsideClickListener);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = OutsideClickListener.__proto__ || (0, _getPrototypeOf2.default)(OutsideClickListener)).call.apply(_ref, [this].concat(args))), _this), _this.state = { mounted: false }, _this.eventListener = function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(e) {
        var _this$props, shouldCallHandler, handler, insideHandler, containerRef, el;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props = _this.props, shouldCallHandler = _this$props.shouldCallHandler, handler = _this$props.handler, insideHandler = _this$props.insideHandler, containerRef = _this$props.containerRef;

                if (!(typeof document !== 'undefined')) {
                  _context.next = 7;
                  break;
                }

                _context.next = 4;
                return containerRef.current;

              case 4:
                _context.t0 = _context.sent;
                _context.next = 8;
                break;

              case 7:
                _context.t0 = null;

              case 8:
                el = _context.t0;


                if (shouldCallHandler === true && containerRef.current === null) {
                  console.error('containerRef is null');
                }

                if (el && !el.contains(e.target)) {
                  if (shouldCallHandler) {
                    handler();
                  }
                } else if (shouldCallHandler) {
                  insideHandler();
                }

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }(), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(OutsideClickListener, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.eventListener);
      this.setState({ mounted: true });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.eventListener);
      this.setState({ mounted: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          containerRef = _props.containerRef;

      if (containerRef) {
        return typeof children === 'function' ? children({ ref: containerRef }) : children;
      } else {
        return null;
      }
    }
  }]);
  return OutsideClickListener;
}(_react2.default.Component);

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['children', 'shouldCallHandler', 'containerRef']));

OutsideClickListener.defaultProps = {
  shouldCallHandler: true,
  handler: function handler() {
    return console.log('clicked outside');
  },
  insideHandler: function insideHandler() {
    return console.log('clicked inside');
  }
};
OutsideClickListener.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]).isRequired,
  shouldCallHandler: _propTypes2.default.bool.isRequired,
  handler: _propTypes2.default.func.isRequired,
  containerRef: _propTypes2.default.object
};

exports.default = enhance(OutsideClickListener);