'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _recompose = require('recompose');

var _react = require('react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ResizeListener = function (_Component) {
  (0, _inherits3.default)(ResizeListener, _Component);

  function ResizeListener() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ResizeListener);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ResizeListener.__proto__ || (0, _getPrototypeOf2.default)(ResizeListener)).call.apply(_ref, [this].concat(args))), _this), _this.listener = function () {
      var _this$props = _this.props,
          setIsOverThreshold = _this$props.setIsOverThreshold,
          threshold = _this$props.threshold,
          _this$props$showLog = _this$props.showLog,
          showLog = _this$props$showLog === undefined ? false : _this$props$showLog;

      showLog && console.log(_this.props);
      if (window.innerWidth >= threshold) {
        setIsOverThreshold(true);
      } else {
        setIsOverThreshold(false);
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ResizeListener, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          setIsOverThreshold = _props.setIsOverThreshold,
          threshold = _props.threshold,
          _props$showLog = _props.showLog,
          showLog = _props$showLog === undefined ? false : _props$showLog;

      showLog && console.log('threshold: ', threshold);
      showLog && console.log('showLog: ', showLog);
      showLog && console.log('this.props: ', this.props);
      typeof window !== 'undefined' && window.innerWidth >= threshold && setIsOverThreshold(true);
      typeof window !== 'undefined' && window.addEventListener('resize', this.listener);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _props2 = this.props,
          threshold = _props2.threshold,
          setIsOverThreshold = _props2.setIsOverThreshold;

      if (prevProps.threshold !== threshold) {
        if (window.innerWidth >= threshold) {
          setIsOverThreshold(true);
        } else {
          setIsOverThreshold(false);
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.listener);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          threshold = _props3.threshold,
          isOverThreshold = _props3.isOverThreshold,
          children = _props3.children;

      return children({ threshold: threshold, isOverThreshold: isOverThreshold });
    }
  }]);
  return ResizeListener;
}(_react.Component);

var enhance = (0, _recompose.compose)((0, _recompose.withState)('isOverThreshold', 'setIsOverThreshold', false));

exports.default = enhance(ResizeListener);